#NoEnv
#SingleInstance, Force

/*
The filaname parameter of Imagen() will also accept a HBITMAP: as parameter.
Unless * is included eg. "HBITMAP:*" . HBM
the passed bitmap will be deleted by Imagen()

When "ahk_id" is present in Options and images are larger than the picture control,
image will be downscaled to fit the control. Images smaller the control will be shown
as is. If you want *any* image to fit the control then use "Upscale" in options.

*/

HBM := LoadPicture("imageres.dll", "Icon80 w256 h256")
Gui, Add, Picture, w512 h512 hWndhPic
Imagen( "HBITMAP:" . HBM, "Upscale ahk_id" . hPic)     ; HBM will be deleted.
Gui, Show
