#NoEnv
#SingleInstance, Force
SetWorkingDir, %A_ScriptDir%
SetBatchLines, -1

; Load GdiPlus.dll or else Imagen() will load/free the DLL for every call.
DllCall("LoadLibrary", "Str","GdiPlus.dll")

Gui, PicView:New,, Imagen - ImageList demo
Gui, Font, s9, Segoe UI
Gui, Margin, 20, 10
Gui, Add, ListView, w172 h480 Icon -Hdr 0x4 LV0x8200 AltSubmit gLVRoutine, Image|Path
Gui, Add, Picture, x+m w640 hp HwndhPic Border
Gui, Font, s8
Gui, Add, StatusBar
Gui, Show

hIML := DllCall("ImageList_Create", "Int",96, "Int",96, "Int",32, "Int",15, "Int",5, "Ptr")
LV_SetImageList(hIML)

Loop, Files, Images\*.jpg
{
    Imagen(A_LoopFileLongPath, "BackgroundTrans w96 h96 Scale", hBM)
    DllCall("ImageList_Add", "Ptr",hIML, "Ptr",hBM, "Ptr",0)
    DllCall("DeleteObject", "Ptr",hBM)
    LV_Add("Icon" . A_Index, A_LoopFileName, A_LoopFileLongPath)
    If (A_Index=1)
      LV_Modify(1, "Focus Select")
}
Return

PicViewGuiEscape:
PicViewGuiClose:
  ExitApp
Return

LVRoutine:
  Critical
  If ( A_GuiEvent="I" && InStr(ErrorLevel, "S", 1) )
  {
      LV_GetText(File, A_EventInfo, 2)
      SB_SetText("  " . File)
      Imagen( File, "FadeIn200ms<3,7,15,31,63,127,255> Background213141 ahk_id" . hPic )
  }
Return